#ifndef _BITOP_H
#define _BITOP_H

// non-0 λ˸Ƥ֤٤
// ϤɤͤƤ٤
static inline int slowbsf(unsigned int mask){
  int mask0= (static_cast<int>(-(mask&0xffff)))>>31;
  mask&=(mask0^0xffff0000);
  int mask1= (static_cast<int>(-(mask&0xff00ff)))>>31;
  mask&=(mask1^0xff00ff00);
  int mask2= (static_cast<int>(-(mask&0xf0f0f0f)))>>31;
  mask&=(mask2^0xf0f0f0f0);
  int mask3= (static_cast<int>(-(mask&0x33333333)))>>31;
  mask&=(mask3^0xcccccccc);
  int mask4= (static_cast<int>(-(mask&0x55555555)))>>31;
  return 31+(mask0&0xfffffff0)+(mask1&0xfffffff8)+
    (mask2&0xfffffffc)+(mask3&0xfffffffe)+mask4;
}

#ifdef i386
#if 1
static inline int bsf(unsigned int mask){
  int ret;
  __asm__("bsfl %1,%0" : "=r"(ret) : "r"(mask));
  return ret;
}
#else
static inline int bsf(unsigned int mask){
  return slowbsf(mask);
}
#endif
#else
#ifdef __x86_64
static inline int bsf(unsigned int mask){
  int ret;
  __asm__("bsfl %1,%0" : "=r"(ret) : "r"(mask));
  return ret;
}
#else
static inline int bsf(unsigned int mask){
  return ffs(mask)-1;
}
#endif
#endif
static inline int countBit(unsigned int mask){
  int count=0;
  for(int i=0;i<32;i++){
    count+=(mask&1);
    mask>>=1;
  }
  return count;
}

#endif // _BITOP_H
