/* standardMoveGenerator.h
 */
#ifndef _STANDARD_MOVE_GENERATOR_H
#define _STANDARD_MOVE_GENERATOR_H

#include "osl/category/categoryList.h"
#include "osl/category/takeBack.h"
#include "osl/category/check.h"
#include "osl/category/kingEscape.h"
#include "osl/category/capture.h"
#include "osl/category/addEffect.h"
#include "osl/category/promote.h"
#include "osl/category/escape.h"
#include "osl/category/defense.h"
#include "osl/category/ptypePosition.h"
#include "osl/category/pawn.h"
#include "osl/category/silver.h"
#include "osl/category/mate.h"
#include "osl/category/classify.h"

#define CL(x,y) CategoryList<x,y >
namespace osl
{
  namespace category
  {
    /**
     * StandardMoveGenerator ǻȤƥΰ 
     *
     * Ψۤɹ⤯ʤޤȤƺäƤʬह륫ƥ
     */
    typedef 
    Classify<
      CL(Escape<GOLD>,
	 CL(Escape<SILVER>,
	    CL(Capture<PAWN>,
	       CL(AddEffectToLastEffect,
		  CL(StabInTheBack,
		     CL(Promote,
			CL(AddEffect,
			   CL(AddSupport,
			      CL(DirectAttackToKing8,
				 CL(DirectDefenseToKing8,
				    CL(SilverHeadOfKnight,
				       CL(SlowApproach,
					  CL(Escape<KNIGHT>,
					     CL(Escape<LANCE>,
						CL(Escape<PAWN>,
						   CL(AntiPromotion,
						      CL(EnteringKing,
							 CL(PtypePosition,
							    NullCategory
							   ))))))))))))))))))>    
    StandardClassifier;
    
    /**
     * ΨõǻȤ MoveGenerator
     *
     * Ψ¬äƱ֤ݤɬפ뤳Ȥ
     */
    typedef 
    CL(KingEscape, 
       CL(TakeBack, 
	  CL(Capture<ROOK>,
	     CL(ContinueCapture,
		CL(Capture<BISHOP>,
		   CL(ImmediateEscape,
		      CL(ImmediateAntiPawnPromotion,
			 CL(JoiningPawns,
			    CL(DropAfterOpposingPawn,
			       CL(SilverHeadOfLastKnight,
				  CL(Check,
				     CL(Escape<ROOK>,
					CL(Escape<BISHOP>,
 					   CL(Capture<GOLD>,
					      CL(Capture<SILVER>,
						 CL(Capture<KNIGHT>,
						    CL(Capture<LANCE>,
						       CL(AddEffectToLastMove,
							  CL(StandardClassifier,
							     NullCategory
							    )))))))))))))))))))
      StandardMoveGenerator;

    /**
     * 2003ǯ긢ˤФ餯ȤäƤ MoveGenerator
     */
    typedef 
    CL(TakeBack, 
       CL(KingEscape, 
	  CL(Check, 
	     CL(Capture<ROOK>,
		CL(Escape<ROOK>,
		   CL(Capture<BISHOP>,
		      CL(Escape<BISHOP>,
			 CL(Classify<	//  move_generator::AllMoves
			    CL(Capture<GOLD>,
			       CL(Escape<GOLD>,
				  CL(Capture<SILVER>,
				     CL(Escape<SILVER>,
					CL(Capture<KNIGHT>,
					   CL(Escape<KNIGHT>,
					      CL(Capture<LANCE>,
						 CL(Escape<LANCE>,
						    CL(Capture<PAWN>,
						       CL(Escape<PAWN>,
							  CL(Promote,
							     CL(AddEffect,
								CL(PtypePosition, NullCategory
								  )))))))))))))>
			    ,NullCategory))))))))   
      OldMoveGenerator;
  } // namespace category

  using category::StandardMoveGenerator;

} // namespace osl
#undef CL

#endif /* _STANDARD_MOVE_GENERATOR_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
