/* oracleProver.h
 */
#ifndef _ORACLEPROVER_H
#define _ORACLEPROVER_H

#include "osl/checkmate/proofOracle.h"
#include "osl/checkmate/checkHashTable.h"
#include "osl/player.h"
namespace osl
{
  namespace checkmate
  {
    /**
     * @param P ¦
     */
    template <Player P, class State>
    class OracleProver
    {
      CheckHashTable& table;
      State *state;
    public:
      OracleProver(CheckHashTable& t) : table(t)
      {
      }
      /** 
       * oracle ˴Ťͤ뤫ɤȽꤹ
       * @param bestMove ͤ˵ͤޤǾ񤭤
       */
      bool proofWin(State& state, ProofOracleAttack oracle, Move& bestMove);
      /** 
       * oracle ˴ŤͤǤ뤫ɤȽꤹ
       * @param state  alt(P) ФƲ꤬äƤ뤳
       */
      bool proofLose(State& state, ProofOracleDefense oracle);

      void attack(CheckHashRecord *& record, ProofOracleAttack oracle);
      void defense(CheckHashRecord *& record, ProofOracleDefense oracle);
    };

  } // namespace checkmate
} // namespace osl

#endif /* _ORACLEPROVER_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
