#ifndef _NO_PROMOTE_MOVE_ACTION_H
#define _NO_PROMOTE_MOVE_ACTION_H

#include "osl/move_action/concept.h"
namespace osl
{
  namespace effect_action
  {
    /**
     * ưʤ
     */
    template<class State,class Action>
    class NoPromote
    {
      BOOST_CLASS_REQUIRE(Action,osl::move_action,Concept);
    private:
      const State& state;
      Action& ac;
    public:
      NoPromote(const State& s, Action & a) : state(s), ac(a){}
      template<Player P,Ptype Type>
      void doActionPtype(Piece p1,Position to){
	if(!isPromoted(p1))
	  ac.unknownMove(getPosition(p1),to,state.getPieceAt(to),Type,false,P);
      }
      template<Player P>
      void doAction(Piece p1,Position to){
	if(!isPromoted(p1))
	  ac.unknownMove(getPosition(p1),to,state.getPieceAt(to),getPtype(p1),false,P);
      }
      bool done() const{ return false;}
    };
  } //namespace effect_action
} // namespace osl
#endif // _NO_PROMOTE_MOVE_ACTION_H
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
