#ifndef _PROMOTE_MOVE_ACTION_H
#define _PROMOTE_MOVE_ACTION_H
#include "osl/move_action/concept.h"
namespace osl
{
  namespace effect_action
  {
    /**
     * SimplePromote Ȱäơ unknownMove Ƥ
     */
    template<class State,class Action>
    class Promote
    {
      BOOST_CLASS_REQUIRE(Action,osl::move_action,Concept);
    private:
      const State& state;
      Action & ac;
    public:
      Promote(const State& s, Action& a) 
	: state(s), ac(a)
      {
      }
      template<Player P,Ptype Type>
      void doActionPtype(Piece p1,Position to){
	Position from=getPosition(p1);
	if(isPromoted(p1))
	  ac.unknownMove(from,to,state.getPieceAt(to),promote(Type),false,P);
	else if(canPromotePosition<P>(to) || canPromotePosition<P>(from))
	  ac.unknownMove(from,to,state.getPieceAt(to),promote(Type),true,P);
      }
      template<Player P>
      void doAction(Piece p1,Position to){
	Position from=getPosition(p1);
	Ptype ptype=getPtype(p1);
	if(isPromoted(p1))
	  ac.unknownMove(from,to,state.getPieceAt(to),ptype,false,P);
	else if(canPromotePosition<P>(to) || canPromotePosition<P>(from))
	  ac.unknownMove(from,to,state.getPieceAt(to),promote(ptype),true,P);
      }
      bool done() const{ return false;}
    };
  } // namespace effect_action
} // namespace osl
#endif
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
