/* hashKeyEqual.h
 */
#ifndef _HASHKEYEQUAL_H
#define _HASHKEYEQUAL_H

#include "osl/hashKey.h"
#include <iostream>

namespace osl
{
  // åդ ==
  // iostream ɬפȤΤ hashKey.h ʬ
  struct HashKeyEqual
  {
    bool operator()(const HashKey& l, const HashKey& r) const
    {
      if ((l.value(0) != r.value(0))
	  || (l.value(1) != r.value(1))
	  || (l.value(2) != r.value(2)))
	return false;
#ifndef HASH_KEY_128_BIT
      return true;
#else
      const bool reallySame = (l.value(3) == r.value(3));
      if (! reallySame)
      {
	std::cerr << "96 bit hash is not enough!\n";
	std::cerr << l << " v.s. " << r << "\n";
      }
      return reallySame;
#endif
    }
  };

} // namespace osl

#endif /* _HASHKEYEQUAL_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
