/* moveLogProbSet.h
 */
#ifndef _MOVELOGPROBSET_H
#define _MOVELOGPROBSET_H

#include "osl/moveMap.h"
#include "osl/moveLogProb.h"

namespace osl
{

  struct MoveLogProbSet : public MoveMap<MoveLogProb>
  {
    /** 
     * ̤Ͽäꡤ¸Ψ⤫äϿ
     * @return Ͽɤ
     */
    bool assignIfBetter(const MoveLogProb& move, int margin=0)
    {
      MoveLogProb *recordedMove = find(move.getMove());
      if (recordedMove)
      {
	// ˤ⤤Ψμ꤬äƤϿʤ
	// 㤤ΨμϾ񤭤
	if (recordedMove->getLogProb() <= move.getLogProb() + margin)
	  return false;
	*recordedMove = move;
      }
      else
      {
	insertNoCheck(move);
      }
      return true;
    }
  };

} // namespace osl


#endif /* _MOVELOGPROBSET_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
