/* moveSorter.h
 */
#ifndef _MOVESORTER_H
#define _MOVESORTER_H
#include "osl/evalCompareLarger.h"
#include "osl/moveLogProb.h"
#include <map>

namespace osl
{
  /**
   * computeBestMoveLower ɾ()⤤˼¤٤
   * Ͼ夫Ĥsort ƤɤΤ over specification ⤷ʤ
   */
  template<Player P>
  struct MtdfMoveSorter : private std::multimap<int,MoveLogProb,EvalCompareLarger<P> >
  {
    typedef std::multimap<int,MoveLogProb,EvalCompareLarger<P> > base_t;
    using base_t::iterator;
    using base_t::const_iterator;
    using base_t::size;
    using base_t::empty;
    using base_t::begin;
    using base_t::end;

    // ŤФϤ餫ᥳѥ뤹
    MtdfMoveSorter();
    ~MtdfMoveSorter();
    
    void insert(const std::pair<int,MoveLogProb>&);
    void insert(typename base_t::iterator hint, const std::pair<int,MoveLogProb>&);
    void erase(typename base_t::iterator first, typename base_t::iterator last);
    void clear();
    void swap(MtdfMoveSorter& o);
    /**
     * @param showElements ɽǤο 0 ʤ
     */
    void dump(size_t showElements=0) const;
  };
}


#endif /* _MOVESORTER_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
