#ifndef _MOVE_VECTOR_H
#define _MOVE_VECTOR_H
#include "osl/move.h"
#include "osl/fixedCapacityVector.h"
#include <iosfwd>
namespace osl
{
  class SimpleState;
  class MoveVector : public FixedCapacityVector<Move,MoveMax>
  {
  public:
    bool isValidAll(const SimpleState& state) const;
  };
  std::ostream& operator<<(std::ostream& os,MoveVector const& mv);
} 
#endif // _MOVE_VECTOR_H
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
