/* storeMoveAction.h
 */
#ifndef _STOREMOVEACTION_H
#define _STOREMOVEACTION_H
#include "osl/moveVector.h"
namespace osl
{
  namespace move_action
  {
    /**
     * ؼ MoveVector ݴ
     */
    struct Store
    {
      MoveVector *moves;		// acquaintance
      Store(MoveVector& v) : moves(&v)
      {
      }
      /** ޤȤʤMove */
      void simpleMove(Position from,Position to,Ptype ptype, bool isPromote,Player p){
	Move move=newMove(from,to,ptype,PTYPE_EMPTY,isPromote,p);
	assert(isValid(move));
	moves->push_back(move);
      }
      /** 
       *	ޤ뤫⤷ʤMove 
       * @param from - ΰư
       * @param to - ΰư
       * @param p1 - ưΥޥζ
       * @param ptype - ưζptype
       * @param isPromote - ꤫?
       * @param p - ץ쥤䡼
       */
      void unknownMove(Position from,Position to,Piece p1,Ptype ptype,bool isPromote,Player p){
	Move move=newMove(from,to,ptype,getPtype(p1),isPromote,p);
	assert(isValid(move));
	moves->push_back(move);
      }
      /** ޤǤMove */
      void dropMove(Position to,Ptype ptype,Player p){
	Move move=newDrop(to,ptype,p);
	assert(isValid(move));
	moves->push_back(move);
      }
    };
  } // namespace move_action
} // namespace osl

#endif /* INCLUDED_STOREMOVEACTION */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
