/* csaIOError.h
 */
#ifndef _CSAIOERROR_H
#define _CSAIOERROR_H

#include <stdexcept>
#include <string>

namespace osl
{
  namespace record
  {
    struct CsaIOError : public std::runtime_error
    {
      CsaIOError(const std::string& w) : std::runtime_error(w)
      {
      }
    };
  } // namespace record
  using record::CsaIOError;
} // namespace osl

#endif /* _CSAIOERROR_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
