/* realizationProbability.h
 */
#ifndef INCLUDED_REALIZATIONPROBABILITY
#define INCLUDED_REALIZATIONPROBABILITY

namespace osl
{
  namespace search
  {
    struct RealizationProbability
    {
      enum {
	reSearch    = 100,
	killerMove  = 200,
	tableMove   = 100,
      };
    };

    struct FullWidthMoveProbability
    {
      enum {
	defaultProb = 500,
	reSearch    = 500,
	killerMove  = 500,
	tableMove   = 500,
      };
    };
  } // namespace search

  using search::RealizationProbability;
  using search::FullWidthMoveProbability;
} // namespace osl

#endif /* INCLUDED_REALIZATIONPROBABILITY */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
