/* searchEvalBase.h
 */
#ifndef _SEARCHEVALBASE_H
#define _SEARCHEVALBASE_H

#include "osl/evalTraits.h"
namespace osl
{
  namespace search
  {
    template <class EvalT>
    struct SearchEvalBase
    {
      typedef EvalT eval_t;
      /** 
       *  Player  template äinline Ÿ硤
       * ƱɤФϤʤΤǡƤӽФ蘆ͥ褹
       */
      static int minusInfty(Player P)
      {
	if (P == BLACK)
	  return eval_t::template minusInfty<BLACK>();
	else
	  return eval_t::template minusInfty<WHITE>();
      }
      static int delta(Player P)
      {
	if (P == BLACK)
	  return EvalTraits<BLACK>::delta;
	else
	  return EvalTraits<WHITE>::delta;
      }
      static int winValue(Player P) 
      {
	return minusInfty(alt(P)) - delta(P)*2;
      }
      static int isWinValue(Player P, int val) 
      {
	return betterThan(P, val, winValue(P) - delta(P)*2);
      }
    };
  } // namespace search
} // namespace osl

#endif /* _SEARCHEVALBASE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
