#include "osl/board.h"
#include "osl/position.h"
#include <iostream>

namespace osl{
std::ostream& operator<<(std::ostream& os,const Position pos){
  if(isOffBoard(pos))
    return os << "OFF";
  return os << "Position(" << getX(pos) << getY(pos) << ")";
}

std::ostream& csaShow(std::ostream& os,const Position pos){
  if(isOffBoard(pos))
    return os << "00";
  return os << getX(pos) << getY(pos);
}

std::ostream& operator<<(std::ostream& os,const Offset off){
  return os << "offset(" << static_cast<int>(off) << ')';
}

}

