#include "osl/checkmate/proofDisProof.h"
#include <boost/static_assert.hpp>
#include <iostream>

namespace osl
{
  namespace checkmate
  {
    BOOST_STATIC_ASSERT(BigProofNumber > PAWN_CHECK_MATE_PROOF);
    BOOST_STATIC_ASSERT(NO_CHECK_MATE_PROOF > PAWN_CHECK_MATE_PROOF);
    std::ostream& operator<<(std::ostream& os,const ProofDisProof proofDisProof){
      return os << "ProofDisProof(" << getProof(proofDisProof) << "," <<
	getDisProof(proofDisProof) << ")" ;
    }
  } // namespace checkmate
} // namespace osl
/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
