#include "osl/moveVector.h"
#include "osl/simpleState.h"
#include <iostream>

namespace osl
{
  std::ostream& operator<<(std::ostream& os,MoveVector const& mv)
  {
    os<< "MoveVector" << std::endl;
    for(size_t i=0; i<mv.size(); i++){
      os << mv[i] << std::endl;
    }
    return os<<std::endl;
  }

  bool MoveVector::isValidAll(const SimpleState& state) const
  {
#if 0
    std::cerr <<  "moves.size=" << moves.size() << std::endl;
#endif
    for (MoveVector::const_iterator it=begin();it!=end();++it){
#if 0
      std::cerr <<  *it << std::endl;
#endif
      if (! state.isValidMove(*it)) 
	return false;
    }
    return true;
  }
}
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
