#include "osl/move_generator/pieceOnBoard.h"
#include "osl/move_generator/pieceOnBoard.tcc"
#include "osl/move_action/store.h"
#include "osl/pawnMaskState.h"

namespace osl
{
  namespace move_generator
  {
    // explicit template instantiation
    template class PieceOnBoard<PawnMaskState, move_action::Store>;
    template void PieceOnBoard<PawnMaskState, move_action::Store>::generateMoves<BLACK,PAWN>(const PawnMaskState&,Piece,move_action::Store&);
    template void PieceOnBoard<PawnMaskState, move_action::Store>::generateMoves<BLACK,LANCE>(const PawnMaskState&,Piece,move_action::Store&);
    template void PieceOnBoard<PawnMaskState, move_action::Store>::generateMoves<BLACK,KNIGHT>(const PawnMaskState&,Piece,move_action::Store&);
    template void PieceOnBoard<PawnMaskState, move_action::Store>::generateMoves<BLACK,SILVER>(const PawnMaskState&,Piece,move_action::Store&);
    template void PieceOnBoard<PawnMaskState, move_action::Store>::generateMoves<BLACK,GOLD>(const PawnMaskState&,Piece,move_action::Store&);
    template void PieceOnBoard<PawnMaskState, move_action::Store>::generateMoves<BLACK,BISHOP>(const PawnMaskState&,Piece,move_action::Store&);
    template void PieceOnBoard<PawnMaskState, move_action::Store>::generateMoves<BLACK,ROOK>(const PawnMaskState&,Piece,move_action::Store&);
    template void PieceOnBoard<PawnMaskState, move_action::Store>::generateMoves<BLACK,KING>(const PawnMaskState&,Piece,move_action::Store&);
    template void PieceOnBoard<PawnMaskState, move_action::Store>::generateMoves<WHITE,PAWN>(const PawnMaskState&,Piece,move_action::Store&);
    template void PieceOnBoard<PawnMaskState, move_action::Store>::generateMoves<WHITE,LANCE>(const PawnMaskState&,Piece,move_action::Store&);
    template void PieceOnBoard<PawnMaskState, move_action::Store>::generateMoves<WHITE,KNIGHT>(const PawnMaskState&,Piece,move_action::Store&);
    template void PieceOnBoard<PawnMaskState, move_action::Store>::generateMoves<WHITE,SILVER>(const PawnMaskState&,Piece,move_action::Store&);
    template void PieceOnBoard<PawnMaskState, move_action::Store>::generateMoves<WHITE,GOLD>(const PawnMaskState&,Piece,move_action::Store&);
    template void PieceOnBoard<PawnMaskState, move_action::Store>::generateMoves<WHITE,BISHOP>(const PawnMaskState&,Piece,move_action::Store&);
    template void PieceOnBoard<PawnMaskState, move_action::Store>::generateMoves<WHITE,ROOK>(const PawnMaskState&,Piece,move_action::Store&);
    template void PieceOnBoard<PawnMaskState, move_action::Store>::generateMoves<WHITE,KING>(const PawnMaskState&,Piece,move_action::Store&);
  } // namespace move_generator
} // namespace osl
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
