#include "osl/carray2d.h"
#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>
using namespace osl;

class carray2dTest : public CppUnit::TestFixture {
  CPPUNIT_TEST_SUITE( carray2dTest );
  CPPUNIT_TEST(testAddress);
  CPPUNIT_TEST_SUITE_END();
public:
  void testAddress();
};

CPPUNIT_TEST_SUITE_REGISTRATION(carray2dTest);

void carray2dTest::testAddress(){
  const size_t c1 = 4, c2 = 3;
  CArray2d<int,c1,c2> a;
  for (size_t i=0; i<c1; ++i)
  {
    for (size_t j=0; j<c2; ++j)
    {
      CPPUNIT_ASSERT_EQUAL(&a(i,j), &a[i][j]);
    }
  }
}
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
