#include "osl/checkmate/proofDisProof.h"
#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>
using namespace osl;

class proofDisProofTest : public CppUnit::TestFixture {
  CPPUNIT_TEST_SUITE(proofDisProofTest);
  CPPUNIT_TEST(testFinal);
  CPPUNIT_TEST_SUITE_END();
 public:
  void testFinal();
};

CPPUNIT_TEST_SUITE_REGISTRATION(proofDisProofTest);

void proofDisProofTest::testFinal(){
  CPPUNIT_ASSERT(isFinal(NoCheckMate));
  CPPUNIT_ASSERT(isFinal(CheckMate));

  CPPUNIT_ASSERT(getProof(PawnCheckMate) > 0);
  CPPUNIT_ASSERT(getDisProof(PawnCheckMate) == 0);
}
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
