#ifndef _HASH_TEST_H
#define _HASH_TEST_H
#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>

class hashTest : public CppUnit::TestFixture {
  CPPUNIT_TEST_SUITE( hashTest );
  CPPUNIT_TEST( testNotEqual );
  CPPUNIT_TEST( testDiff );
  CPPUNIT_TEST( testHashUniqueness );
  CPPUNIT_TEST( testDoUndoMove );
  CPPUNIT_TEST_SUITE_END();
 private:
 public:
  void testNotEqual();
  void testDiff();
  void testHashUniqueness();
  void testDoUndoMove();
};

#endif /* _HASH_TEST_H */
