#include "osl/kanjiPrint.h"
#include "osl/pawnMaskState.h"
#include "osl/record/csaString.h"
#include <iostream>

#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>

class kanjiPrintTest : public CppUnit::TestFixture {
  CPPUNIT_TEST_SUITE(kanjiPrintTest);
  CPPUNIT_TEST(testShow);
  CPPUNIT_TEST_SUITE_END();
 public:
  void testShow();
};

CPPUNIT_TEST_SUITE_REGISTRATION(kanjiPrintTest);

using namespace osl;
extern bool isShortTest;

void kanjiPrintTest::testShow(){
  PawnMaskState state=CsaString(
"P1+NY+TO *  *  *  * -OU-KE-KY\n"
"P2 *  *  *  *  * -GI-KI *  *\n"
"P3 * +RY *  * +UM * -KI-FU-FU\n"
"P4 *  * +FU-FU *  *  *  *  *\n"
"P5 *  * -KE * +FU *  * +FU *\n"
"P6-KE *  * +FU+GI-FU *  * +FU\n"
"P7 *  * -UM *  *  *  *  *  *\n"
"P8 *  *  *  *  *  *  *  *  * \n"
"P9 * +OU * -GI *  *  *  * -NG\n"
"P+00HI00KI00KE00KY00FU00FU00FU00FU00FU00FU\n"
"P-00KI00KY00FU00FU\n"
"P-00AL\n"
"+\n").getInitialState();

  KanjiPrint printer(std::cerr);
  if (! isShortTest)
    printer.print(state);
  PawnMaskState state1(HIRATE);
  if (! isShortTest)
    printer.print(state1);
}

// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
