#ifndef _CSA_TEST_H
#define _CSA_TEST_H

#include "osl/record/csa.h"
#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>
#include <vector>

class csaTest : public CppUnit::TestFixture {
  CPPUNIT_TEST_SUITE( csaTest );
  CPPUNIT_TEST( testShow );
  CPPUNIT_TEST( testSpeed );
  CPPUNIT_TEST( testSpeedGame );
  CPPUNIT_TEST_SUITE_END();
 private:
  osl::Record rec;
  osl::PawnMaskState state;
  std::vector<osl::Move> moves;
#if 0
  int level;
  struct doUndoRec2 {
    inline int operator()(){
      return doUndoGameSub2();
    }
  };
  int doUndoGameSub2();
#endif

  void doUndoGameSub(unsigned int index);
 public:
  int doUndoGameSub1(unsigned int index);
  void setUp();
  void testShow();
  void testLoad();
  void testSpeed();
  void testSpeedGame();
};

#endif /* _CSA_TEST_H */
