#ifndef _KISEN_TEST_H
#define _KISEN_TEST_H

#include "osl/record/kisen.h"
#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>
#include <vector>

class kisenTest : public CppUnit::TestFixture {
  CPPUNIT_TEST_SUITE( kisenTest );
  CPPUNIT_TEST( testShow );
  CPPUNIT_TEST( testConsistent );
  CPPUNIT_TEST_SUITE_END();
 private:
  osl::Record rec;
  osl::PawnMaskState state;
  std::vector<osl::Move> moves;
 public:
  void setUp();
  void testShow();
  void testConsistent();
};

CPPUNIT_TEST_SUITE_REGISTRATION( kisenTest );
#endif /* _KISEN_TEST_H */
