#include "mtdfRecorderTest.h"
#include "osl/search/searchRecorder.h"
#include "osl/moveLogProb.h"

CPPUNIT_TEST_SUITE_REGISTRATION(mtdfRecorderTest);

using namespace osl;

void mtdfRecorderTest::testWrite(){
  SearchRecorder recorder("mtdfRecorderTest.log");
  MoveLogProb m(newMove(newPosition(6,5),newPosition(2,1),PBISHOP,KNIGHT,true,BLACK),
		7777777);
  recorder.tryMove(m, 111, 11111);
  recorder.recordValue(m, 222, true, 22222);
  recorder.recordTopLevelLowFail(m, 333);
  recorder.recordTopLevelHighFail(m, 444);
  recorder.startSearch(555);
  recorder.finishSearch(m, 666);
}

// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
