/* checkMoveList.h
 */
#ifndef _CHECK_MOVELIST_H
#define _CHECK_MOVELIST_H

#include "osl/move.h"
#include <vector>
#include <cassert>

namespace osl
{
  namespace checkmate
  {
    class CheckHashRecord;
    /** 
     * ;ǻȤؤΥꥹ
     */
    struct CheckMove
    {
      Move move;
      /** move ؤrecord */
      CheckHashRecord *record;
      /** cost */
      signed char costProof, costDisProof;
      explicit CheckMove(Move m=MOVE_INVALID, CheckHashRecord *r=0) 
	: move(m), record(r), costProof(0), costDisProof(0)
      {
      }
      void addCost(unsigned& proof, unsigned int& disProof) const
      {
	// TODO: ξȽϸƤӽФ¦˰ܤơassert ˤ
	if (proof && disProof)
	{
	  proof = std::max(1, (int)proof + costProof);
	  disProof = std::max(1, (int)disProof + costDisProof);
	}
      }
    };
    // slist  vector ®
    typedef std::vector<CheckMove> CheckMoveListBase;
    class CheckMoveList : public CheckMoveListBase
    {
    public:
    };
  } // namespace checkmate
} // namespace osl

#endif /* _CHECK_MOVELIST_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
