/* tableAnalyzer.h
 */
#ifndef _TABLE_HANALYZER_H
#define _TABLE_HANALYZER_H

#include <iosfwd>
#include <cstddef>
namespace osl
{
  namespace checkmate
  {
    class CheckHashRecord;
    /**
     * ;õΥơ֥ʬ
     *
     * õڤ礭ȡĤɬפڤ礭
     * (ǾڤȤϸ¤ʤ)ɬפʻʤɤ
     */
    class CheckTableAnalyzer
    {
    public:
      CheckTableAnalyzer();
      ~CheckTableAnalyzer();
    
      /**
       * record  root Ȥڤ񤭽Ф
       */
      void showTree(const CheckHashRecord *record, std::ostream& os,
		    int maxDepth, bool expandFinalState=true, bool showTerminalMoves=false) const;
      /**
       * ơ֥state ãǽʶ̤οĴ٤
       */
      size_t treeSize(const CheckHashRecord *record) const;
      /**
       * ơ֥state ξΤɬפʶ̤οĴ٤
       * @return state  ͤߤǤԵͤǤʤ 0 
       */
      size_t proofTreeSize(const CheckHashRecord *record, bool orNode) const;
      /**
       * ơ֥state ξΤɬפڤɽ
       */
      size_t showProofTree(const CheckHashRecord *record, bool orNode, std::ostream& os) const;
    };
  } // namespace checkmate
  using checkmate::CheckTableAnalyzer;
} // namespace osl

#endif /* _TABLE_HANALYZER_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
