/* simpleCheckHashTable.h
 */
#ifndef _SIMPLE_CHECK_HASHTABLE_H
#define _SIMPLE_CHECK_HASHTABLE_H

#include "osl/checkmate/proofDisProof.h"
#include <boost/scoped_ptr.hpp>

namespace osl
{
  class HashKey;

  namespace checkmate
  {
    class CheckHashRecord;
    /**
     * ;ѤΥơ֥
     * ArrayCheckHashTable Ȱä̤ѤϤǤʤ
     */
    class SimpleCheckHashTable
    {
      class Table;
      boost::scoped_ptr<Table> table;
      const Player attacker;
    public:
      explicit SimpleCheckHashTable(Player attacker);
      ~SimpleCheckHashTable();

      CheckHashRecord *find(const HashKey& key);
      CheckHashRecord *allocate(const HashKey& key);

      void clear();

      const CheckHashRecord *find(const HashKey& key) const;
      size_t size() const;
      Player getAttacker() const { return attacker; }
      void confirmNoVisitedRecords() const;
    };
    
  } // namespace checkmate
} // namespace osl

#endif /* _SIMPLE_CHECK_HASHTABLE_H_ */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
