#ifndef _EFFECT_PASS_H
#define _EFFECT_PASS_H
#include "osl/direction.h"
#include "osl/ptype.h"
#include "osl/piece.h"
#include "osl/board.h"
#include "osl/carray.h"

namespace osl{
  // θ
  // ӥå 0-7ϳΥѥȴ뤫ɤ?
  // ӥå 8-15ϳΥѥ1ĤΤФɤ
  // θ
  // ӥå 16-23ϳ(鸫)Υѥȴ뤫ɤ?
  // ӥå 24-31ϳ(鸫)Υѥ1ĤΤФɤ
  enum EffectPass{
    EFFECT_PASS__MIN=0,
    EFFECT_PASS_EMPTY=0x00ff00ff,
    EFFECT_PASS__MAX=0xffffffff
  };
  
  class PtypeOToEffectPass{
  protected:
    CArray<EffectPass, PTYPEO_SIZE> masks;
  public:
    PtypeOToEffectPass(){
      init();
    }
    void init();
    EffectPass getEffectPass(PtypeO ptypeo) const{
      assert(PTYPEO_MIN<=ptypeo && ptypeo<=PTYPEO_MAX);
      return masks[ptypeo-PTYPEO_MIN];
    }
  };
  extern PtypeOToEffectPass ptypeOToEffectPass;
  
}
#endif // _EFFECT_PASS_H
