/* generateCaptureMoves.h
 */
#ifndef _GENERATECAPTUREMOVES_H
#define _GENERATECAPTUREMOVES_H

#include "osl/position.h"
#include "osl/player.h"
#include "osl/piece.h"
#include "osl/move_action/concept.h"
// CaptureMoves<NumEffectState, StoreMoveAction> ʳȤ߹碌ǻȤȤ
// generateCaptureMoves.tcc include 뤳 (âѥ֤Τǿ侩ʤ)

namespace osl
{
  namespace move_generator
  {
    /**
     * 
     */
    template<class State,class Action>
    class Capture
    {
      BOOST_CLASS_REQUIRE(Action,osl::move_action,Concept);
    public:
      /**
       * @param target ΰ (can be empty)
       */
      template<Player P>
      static void generateMoves(const State& state,Position target,
				Action& action);
      static void generateMoves(Player p, const State& state,Position target,
				Action& action);
      /**
       * @param target ΰ (can be empty)
       * @param piece  ζʳǼ
       */
      template<Player P>
      static void generateMovesNotBy(const State& state,Position target,
				     Piece piece,Action& action);
      static void generateMovesNotBy(Player p, const State& state,Position target,
				     Piece piece,Action& action);
    };
  } // namespace move_generator
} // namespace osl


#endif /* _GENERATECAPTUREMOVES_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
