/* bitXmask.cc
 */
#include "osl/bitXmask.h"
#include "osl/board.h"
#include <iostream>

osl::BoardTable const osl::boardTable;

osl::BoardTable::BoardTable(){
    // std::fill(setMask.begin(), setMask.end(), 0);
  setMask.clear();
  for(int x=9;x>0;x--)
    for(int y=1;y<=9;y++){
      Position pos=newPosition(x,y);
      setMask[pos]=1<<x;
    }
}

osl::BoardTable::~BoardTable(){
}

std::ostream& osl::operator<<(std::ostream& os,const BitXmask mask){
  for(int i=1;i<=9;i++)
    os << ((static_cast<int>(mask)>>(i))&1);
  return os;
}

/* ------------------------------------------------------------------------- */
