#include "osl/effectPass.h"
#include <iostream>
#include <iomanip>
namespace osl{
  PtypeOToEffectPass ptypeOToEffectPass;
}

void osl::PtypeOToEffectPass::init(){
#if 0
  std::fill(masks.begin(), masks.end(), static_cast<EffectPass>(0));
#endif
  masks.clear();

  masks[PTYPEO_EMPTY-PTYPEO_MIN]=EFFECT_PASS_EMPTY;
  ptypeTable.init();
  for(int pl= -1;pl<=0;pl++){
    Player player=static_cast<Player>(pl);
    int plIndex=playerToIndex(player);
    for(int i=static_cast<int>(PPAWN);i<=static_cast<int>(ROOK);i++){
      Ptype ptype=static_cast<Ptype>(i);
      PtypeO ptypeO=newPtypeO(player,ptype);
#if 0
      if(ptype==KING){
	// θ1ĴӤƤȲꤹԹ礬ɤ
	masks[static_cast<int>(ptypeO)-PTYPEO_MIN]=static_cast<EffectPass>(0xff00ff00);
      }
      else
#endif
      {
	int mask=ptypeTable.getMoveMask(ptype);
	if(pl==-1){ /* λȿž */
	  int newMask=0;
	  for(int i=0;i<8;i++){
	    if((mask&(1<<i))!=0)
	      newMask|=(1<<(7-i));
	    if((mask&(1<<(i+LONG_UL)))!=0)
	      newMask|=(1<<(LONG_UL+7-i));
	  }
	  mask=newMask;
	}
	std::cout << "mask of " << ptypeO << "=" << std::setbase(16) << mask << std::endl << std::setbase(10);
	masks[static_cast<int>(ptypeO)-PTYPEO_MIN]=
	  static_cast<EffectPass>((((mask>>LONG_UL)&0xff)|((mask&0xff)<<8))<<(16*plIndex));
      }
    }
  }
}
