#include "osl/piece.h"
#include "osl/pieceMask.h"
#include <iostream>

namespace osl{
  bool operator==(const PieceMask &m1, const PieceMask &m2){
    return m1.getMask(0)==m2.getMask(0) && m1.getMask(1)==m2.getMask(1);
  }

  std::ostream& operator<<(std::ostream& os,const PieceMask pieceMask){
    os << "PieceMask(";
    for(int i=0;i<32;i++)
      os << ((pieceMask.getMask(0)>>i)&1);
    os << ',';
    for(int i=0;i<PIECE_SIZE-32;i++)
      os << ((pieceMask.getMask(1)>>i)&1);
    return os << ')';
  }
}
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
